﻿Public MustInherit Class Person

    Private _id As Integer
    Public ReadOnly Property id() As Integer
        Get
            Return _id
        End Get
    End Property

    Private _firstName As String
    Public Property firstname() As String
        Get
            Return _firstName
        End Get
        Set(ByVal value As String)
            _firstName = value
        End Set
    End Property

    Private _lastname As String
    Public Property lastname() As String
        Get
            Return _lastname
        End Get
        Set(ByVal value As String)
            _lastname = value
        End Set
    End Property

    Private _gender As Boolean
    Public Property gender() As Boolean
        Get
            Return _gender
        End Get
        Set(ByVal value As Boolean)
            _gender = value
        End Set
    End Property

    Private _address As String
    Public Property address() As String
        Get
            Return _address
        End Get
        Set(ByVal value As String)
            _address = value
        End Set
    End Property


    Public Sub New(id As Integer, fname As String, lname As String, gender As Boolean, address As String)
        Me._id = id
        Me.firstname = fname
        Me.lastname = lname
        Me.gender = gender
        Me.address = address
    End Sub

    Public Sub New(id As Integer)
        Me._id = id
    End Sub


    Public Overrides Function toString() As String
        Return Me.id.ToString + " ) " + Me.firstname + " " + Me.lastname
    End Function

End Class
